#include <bits/stdc++.h>

using namespace std;

const int N = (int) 1e5 + 10;

int tree[16 * N], add[4 * N], cur_timer = 0, tin[N], tout[N];
int to_add[16 * N];

void push_add(int v, int l, int r) {
    if (to_add[v] == 0)
        return;
    tree[v] += to_add[v] * (r - l + 1);
    if (l != r)
        to_add[v * 2] += to_add[v], to_add[v * 2 + 1] += to_add[v];
    to_add[v] = 0;
}

void update_add(int v, int l, int r, int tl, int tr, int val) {
    push_add(v, l, r);
    if (l > tr || r < tl)
        return;
    if (l >= tl && r <= tr) {
        to_add[v] += val;
        push_add(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update_add(v * 2, l, mid, tl, tr, val);
    update_add(v * 2 + 1, mid + 1, r, tl, tr, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get_add(int v, int l, int r, int pos) {
    push_add(v, l, r);
    if (l == r)
        return tree[v];
    int mid = (l + r) / 2;
    if (pos <= mid)
        return get_add(v * 2, l, mid, pos);
    return get_add(v * 2 + 1, mid + 1, r, pos);
}

void push(int v, int l, int r) {
    if (add[v] == -2)
        return;
    tree[v] = add[v] * (r - l + 1);
    if (l != r)
        add[v * 2] = add[v], add[v * 2 + 1] = add[v];
    add[v] = -2;
}

int t[N];

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl)
        return;
    if (l >= tl && r <= tr) {
        add[v] = val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val);
    update(v * 2 + 1, mid + 1, r, tl, tr, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get(int v, int l, int r, int pos) {
    push(v, l, r);
    if (l == r)
        return tree[v];
    int mid = (l + r) / 2;
    if (pos <= mid) return get(v * 2, l, mid, pos);
    return get(v * 2 + 1, mid + 1, r, pos);
}

int ans[N], timer = 1, l[N], r[N], sz[N];

bool DO = true;

void calc(int v) {
    if (v == 0)
        return;
    sz[v] = 1;
    tin[v] = cur_timer++;
    if (DO)
        t[v] = get(1, 0, N - 1, v);
    if (t[v] == -1) ans[v] = timer++;
    calc(l[v]);
    if (t[v] == 0) ans[v] = timer++;
    calc(r[v]);
    if (t[v] == 1) ans[v] = timer++;
    tout[v] = cur_timer++;
    if (l[v] != 0)sz[v] += sz[l[v]];
    if (r[v] != 0)sz[v] += sz[r[v]];
}

struct query {
    int type, a, b, x, i;
};

bool LOCAL = false;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    fill(add, add + 4 * N, -2);

    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        t[i] = -1;
        int a, b;
        cin >> a >> b;
        l[i] = a, r[i] = b;
    }
    bool was = false, check = true;
    bool second_check = false;
    vector<query> queries(q);
    int count_1 = 0;
    for (int i = 0; i < q; i++) {
        cin >> queries[i].type;
        if (queries[i].type == 1) {
            cin >> queries[i].a >> queries[i].b >> queries[i].x, count_1++;
            if (queries[i].a != queries[i].b)
                second_check = true;
            if (was)check = false;
        } else
            cin >> queries[i].i, was = true;
    }
    DO = false;
    calc(1);
    DO = true;
    if (!second_check) {
        for (int cur = 0; cur < q; cur++) {
            int type = queries[cur].type;
            if (type == 1) {
                int a = queries[cur].a, b = queries[cur].b, x = queries[cur].x;
                if (t[a] == -1) {
                    update_add(1, 0, N - 1, tin[a] + 1, tout[a], -1);
                } else if (t[a] == 0) {
                    if (r[a] != 0)
                        update_add(1, 0, N - 1, tin[r[a]], tout[r[a]], -1);
                    if (l[a] != 0)
                        update_add(1, 0, N - 1, tin[a], tin[a], -sz[l[a]]);
                } else if (t[a] == 1)
                    update_add(1, 0, N - 1, tin[a], tin[a], -sz[a] + 1);
                if (x == -1) {
                    update_add(1, 0, N - 1, tin[a] + 1, tout[a], 1);
                } else if (x == 0) {
                    if (r[a] != 0)
                        update_add(1, 0, N - 1, tin[r[a]], tout[r[a]], 1);
                }
                if (x == 0) {
                    if (l[a] != 0)
                        update_add(1, 0, N - 1, tin[a], tin[a], sz[l[a]]);
                } else if (x == 1)
                    update_add(1, 0, N - 1, tin[a], tin[a], sz[a] - 1);
                t[a] = x;
            } else {
                int i = queries[cur].i;
                cout << get_add(1, 0, N - 1, tin[i]) + ans[i] << "\n";
            }
        }
        return 0;
    }
    for (int i = 1; i <= n; i++)
        update(1, 0, N - 1, i, i, t[i]);
    if (!LOCAL) {
        if (count_1 <= 10 || (n <= 5000 && q <= 5000)) {
            DO = false;
            for (int cur = 0; cur < q; cur++) {
                int type = queries[cur].type;
                if (type == 1) {
                    timer = 1;
                    int a = queries[cur].a, b = queries[cur].b, x = queries[cur].x;
                    for (int i = a; i <= b; i++) {
                        t[i] = x;
                    }
                    calc(1);
                } else {
                    int i = queries[cur].i;
                    cout << ans[i] << "\n";
                }
            }
            return 0;
        }
        timer = 1;
        if (check) {
            for (int cur_q = 0; cur_q < q; cur_q++) {
                int type = queries[cur_q].type;
                if (type == 1) {
                    update(1, 0, N - 1, queries[cur_q].a, queries[cur_q].b, queries[cur_q].x);
                    if (cur_q + 1 < q && queries[cur_q + 1].type == 2)
                        calc(1);
                } else {
                    cout << ans[queries[cur_q].i] << "\n";
                }
            }
            return 0;
        }
    }
    vector<int> pr[n + 1];
    function<void(int)> calcc = [&](int v) {
        if (v == 0)return;
        if (l[v] != 0)
            for (auto x: pr[v])
                pr[l[v]].emplace_back(x);
        if (r[v] != 0)
            for (auto x: pr[v])
                pr[r[v]].emplace_back(x);
        if (l[v] != 0)pr[l[v]].emplace_back(v);
        if (r[v] != 0)pr[r[v]].emplace_back(v);
        calcc(l[v]), calcc(r[v]);
    };
    calcc(1);
    for (int cur_q = 0; cur_q < q; cur_q++) {
        int type = queries[cur_q].type;
        if (type == 1) {
            update(1, 0, N - 1, queries[cur_q].a, queries[cur_q].b, queries[cur_q].x);
        } else {
            int v = queries[cur_q].i, res = 0, cur = n;
            pr[v].emplace_back(v);
            for (int i = 0; i < (int) pr[v].size() - 1; i++) {
                int u = pr[v][i], tp = get(1, 0, N - 1, u);
                if (tp == -1) {
                    res++;
                    if (pr[v][i + 1] != l[u]) {
                        res += (cur - 1) / 2;
                    }
                } else if (tp == 0) {
                    if (pr[v][i + 1] != l[u]) {
                        res += (cur - 1) / 2;
                        res++;
                    }
                } else {
                    if (pr[v][i + 1] != l[u]) {
                        res += (cur - 1) / 2;
                    }
                }
                cur = (cur - 1) / 2;
            }
            pr[v].pop_back();
            int tp = get(1, 0, N - 1, v);
            if (tp == 0) {
                res += (cur - 1) / 2;
            } else if (tp == 1) {
                res += cur - 1;
            }
            cout << res + 1 << '\n';
        }
    }
    return 0;
}