#include <bits/stdc++.h>

using namespace std;

const int N = (int) 1e5 + 10;

int tree[4 * N], add[4 * N], cur_timer = 0;

void push(int v, int l, int r) {
    if (add[v] == -2)
        return;
    tree[v] = add[v] * (r - l + 1);
    if (l != r)
        add[v * 2] = add[v], add[v * 2 + 1] = add[v];
    add[v] = -2;
}

int t[N];

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl)
        return;
    if (l >= tl && r <= tr) {
        add[v] = val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val);
    update(v * 2 + 1, mid + 1, r, tl, tr, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get(int v, int l, int r, int pos) {
    push(v, l, r);
    if (l == r)
        return tree[v];
    int mid = (l + r) / 2;
    if (pos <= mid) return get(v * 2, l, mid, pos);
    return get(v * 2 + 1, mid + 1, r, pos);
}

int ans[N], timer = 1, l[N], r[N];

void calc(int v) {
    if (v == 0)
        return;
    t[v] = get(1, 0, N - 1, v);
    if (t[v] == -1) ans[v] = timer++;
    calc(l[v]);
    if (t[v] == 0) ans[v] = timer++;
    calc(r[v]);
    if (t[v] == 1) ans[v] = timer++;
}

struct query {
    int type, a, b, x, i;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    fill(add, add + 4 * N, -2);

    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        t[i] = -1;
        int a, b;
        cin >> a >> b;
        l[i] = a, r[i] = b;
        update(1, 0, N - 1, i, i, t[i]);
    }
    vector<query> queries(q);
    int count_1 = 0;
    for (int i = 0; i < q; i++) {
        cin >> queries[i].type;
        if (queries[i].type == 1)
            cin >> queries[i].a >> queries[i].b >> queries[i].x, count_1++;
        else
            cin >> queries[i].i;
    }
    calc(1);
    if (count_1 <= 10 || (n <= 5000 && q <= 5000)) {
        for (int cur = 0; cur < q; cur++) {
            int type = queries[cur].type;
            if (type == 1) {
                timer = 1;
                int a = queries[cur].a, b = queries[cur].b, x = queries[cur].x;
                for (int i = a; i <= b; i++) {
                    t[i] = x;
                    update(1, 0, N - 1, i, i, t[i]);
                }
                calc(1);
            } else {
                int i = queries[cur].i;
                cout << ans[i] << "\n";
            }
        }
        return 0;
    }
    for (int cur_q = 0; cur_q < q; cur_q++) {
        int type = queries[cur_q].type;
        if (type == 1) {
            update(1, 0, N - 1, queries[cur_q].a, queries[cur_q].b, queries[cur_q].x);
            if (cur_q + 1 < q && queries[cur_q + 1].type == 2)
                calc(1);
        } else {
            cout << ans[queries[cur_q].i] << "\n";
        }
    }
    return 0;
}